#!/usr/bin/tixwish4.1.8.0
#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: SchemaEditor.tcl,v 1.4 2000/10/15 17:19:20 artur Exp $
#
# Information:
# Startdatei (Schema Editor)
# Kann die Data Dictionary (Data Catalog) in eine XML DB Schema Umsetzten
# Dabe knnen die zustliche Informationen 
# (Wie die Relationen interpretiert werden) in einer GUI ergnzt werden
#
# Load XOTcl Extension

# Finde Program-Verzeichnis
set sname [info script]
if {$sname==""} {
    # Run interactive for develop purposes
    set progdir /home/artur/diplom/program
} else {
    file lstat $sname stats
    # follow sym links
    if {$stats(type)=="link"} {
	set sname [file readlink $sname]
	if {[file pathtype $sname]=="relative"} {
	    set sname [file join [file dirname [info script]] $sname]
	}
    }
    set progdir [file dirname $sname]
}
wm withdraw .
# Lade Weitere Tcl Komponenten Xotc,tDom,TclX
source [file join $progdir Init.tcl]

#Lade andere Module
source [file join $progdir sql.tcl]
source [file join $progdir sqlschema_ext.tcl]
source [file join $progdir schemaedit.tcl]
source [file join $progdir ass_assistent.tcl]
source [file join $progdir revengeneering.tcl]

#Setzte Array lan mit bersetzung-Strings
checklanguage se
#Dom Schnittstelle auch auf deutsche Umlauten setzten
dom setResultEncoding iso8859-1

# Haupt-Objekt des Programm das die GUI aufbaut und kontroliert
# Nur ein per Ausfhrung

Object ProgGui
source [file join $progdir prog_func.tcl]
ProgGui proc setwin window {
    [self] instvar win hlist actuel_edit editframe  \
	v_foreignkey_attr v_attr v_attr_group v_ass_target \
	v_ass_collection v_aggr_table v_child_table v_ass_table v_table_label
    set v_foreignkey_attr 1
    set v_attr 1
    set v_attr_group 1
    set v_ass_target  1
    set v_ass_collection  1
    set v_aggr_table  1
    set v_child_table  1
    set v_ass_table 1
    set v_table_label 1
    set win $window
    set actuel_edit {}
    global lan
    menu $win.mb -tearoff 0
    menu $win.mb.file -tearoff 0
    menu $win.mb.view -tearoff 0
    menu $win.mb.reverse -tearoff 0
    menu $win.mb.help -tearoff 0
    
    $win.mb add cascade -label $lan(menu.file.file) -menu $win.mb.file \
	-underline 0
    $win.mb add cascade -label $lan(menu.view.view) -menu $win.mb.view \
	-underline 0
    $win.mb add cascade -label $lan(menu.reverse.reverse) -menu $win.mb.reverse \
	-underline 0
    $win.mb add cascade -label $lan(menu.help.help) -menu $win.mb.help \
	-underline 0
    
    $win.mb.file add command -label $lan(menu.file.readdbschema) \
	-command {ProgGui readdbschema}
    $win.mb.file add command -label $lan(menu.file.readxmlschema) \
	-command {ProgGui readxmlschema}
    $win.mb.file add separator
    $win.mb.file add command -label $lan(menu.file.saveasxml) \
	-command {ProgGui saveasxml}
#    $win.mb.file add command -label $lan(menu.file.savetodb) \
#	-command {ProgGui saveasxmltodb}
    $win.mb.file add separator
    $win.mb.file add command -label $lan(menu.file.exit) \
	-command {ProgGui handle_exit}

#     $win.mb.view add command -label $lan(menu.view.extend) \
# 	-command {ProgGui extend_view}    
#     $win.mb.view add command -label $lan(menu.view.restrict) \
# 	-command {ProgGui restrict_view}    
    $win.mb.view add command -label $lan(menu.view.suit) \
 	-command {$ProgGui::win.panedwin.tree.tree autosetmode}    
    $win.mb.view add separator
    $win.mb.view add checkbutton -label $lan(menu.view.attr) \
	-command {ProgGui changeView}  -variable ProgGui::v_attr
    $win.mb.view add checkbutton -label $lan(menu.view.attr_group) \
	-command {ProgGui changeView}  -variable ProgGui::v_attr_group
    $win.mb.view add checkbutton -label $lan(menu.view.ass_target) \
	-command {ProgGui changeView}  -variable ProgGui::v_ass_target
    $win.mb.view add checkbutton -label $lan(menu.view.ass_collection) \
	-command {ProgGui changeView}  -variable ProgGui::v_ass_collection
    $win.mb.view add checkbutton -label $lan(menu.view.aggr_table) \
	-command {ProgGui changeView}  -variable ProgGui::v_aggr_table
    $win.mb.view add checkbutton -label $lan(menu.view.child_table) \
	-command {ProgGui changeView}  -variable ProgGui::v_child_table
    $win.mb.view add checkbutton -label $lan(menu.view.ass_table) \
	-command {ProgGui changeView}  -variable ProgGui::v_ass_table
    $win.mb.view add checkbutton -label $lan(menu.view.table_label) \
	-command {ProgGui changeView}  -variable ProgGui::v_table_label

    $win.mb.reverse add command -label $lan(menu.reverse.foreignkey) \
	-command {ProgGui reverseEngeneering foreignkeys}
    $win.mb.reverse add command -label $lan(menu.reverse.heritage) \
	-command {ProgGui reverseEngeneering heritage}
    $win.mb.reverse add command -label $lan(menu.reverse.assoziation_rel) \
	-command {ProgGui reverseEngeneering assoziation_rel}
    $win.mb.reverse add command -label $lan(menu.reverse.aggregation) \
	-command {ProgGui reverseEngeneering aggregation}

    $win.mb.help add command -label $lan(menu.help.help) \
	-command handle_help
    $win.mb.help add command -label $lan(menu.help.about) \
	-command {handle_about SchemaEditor}
    $win.mb.help add separator
    $win.mb.help add command -label $lan(menu.help.debug) \
	-command {commandloop}
    $win.mb.help add command -label inspector \
	-command {source [file join $progdir inspector.tcl]}
    $win.mb.help add command -label win_inspector \
	-command {source [file join $progdir win_inspector.tcl]}
    $win.mb.help add command -label "view XML Schema" \
	-command {
	    if {![winfo exist .xmlview]} {
		toplevel .xmlview
		tixScrolledText .xmlview.st
		pack  .xmlview.st -expand yes -fill both
	    }
	    .xmlview.st subwidget text delete 1.0 end
	    .xmlview.st subwidget text insert 1.0 [$ProgGui::data_node asXML]
	}
    tixPanedWindow $win.panedwin -paneborderwidth 0 -separatorbg gray50 \
	-orientation horizontal
    set p1 [$win.panedwin add tree -min 150 -size 200]
    set p2 [$win.panedwin add lframe -min 400]
    tixTree $p1.tree -command "[self] mlist_sel" -options {
	hlist.separator "."
    }
    set hlist [$p1.tree subwidget hlist]
    frame $p2.lframe
    set editframe $p2.lframe
    frame $win.box -relief raised -bd 2
    button $win.box.edit -text $lan(button.edit) -command {
	ProgGui mlist_sel [$ProgGui::hlist info selection]
    }  -width 10
    #button $win.box.add  -text $lan(button.add)  -command "exit" -width 10
    button $win.box.ass -text $lan(button.ass_assistent) -command {AssAssistent execute $ProgGui::data_node} -width 10
    button $win.box.aggr -text $lan(button.aggr_assistent) -command {AggrAssistent execute $ProgGui::data_node} -width 10
    button $win.box.inherit -text $lan(button.inherit_assistent) -command {InheritAssistent execute $ProgGui::data_node} -width 10

    button $win.box.up -image [tix getimage up] \
	-command "[self] elementUp" \
	-takefocus 0 -bg #c0c0c0 -highlightbackground #c0c0c0
    button $win.box.down -image [tix getimage down] \
	-command "[self] elementDown" \
	-takefocus 0 -bg #c0c0c0 -highlightbackground #c0c0c0

    pack $win.box.edit $win.box.ass $win.box.aggr $win.box.inherit \
	$win.box.up $win.box.down -side top -anchor w
    
    pack $win.box -side right -anchor e -fill y -expand yes -in $p2.lframe
    pack $p1.tree -expand yes -fill both -padx 4 -pady 6
    pack $p2.lframe -expand yes -fill both -padx 4 -pady 6
    pack $win.panedwin -expand yes -fill both 
    
    if {$win==""} {
	. configure -menu $win.mb
	wm protocol . WM_DELETE_WINDOW "[self] handle_exit"
    } else {
	$win configure -menu $win.mb
	wm protocol $win WM_DELETE_WINDOW "[self] handle_exit"
    }
    bind $hlist <ButtonPress-3> "[self] popmenuTree %X %Y"
}
ProgGui proc readdbschema {} {
    [self] instvar win data_node dom_doc hlist file_name
    if {[ConnectCreator getconnect sqlconnect {} 1]==""} { 
	global errorInfo lan
	tk_messageBox -message "$lan(connect.noconnect)\n$errorInfo" -type ok -icon warning
	return 
    }
    [self] clearSchema
    set dom_doc [dom createDocument database]
    set data_node [$dom_doc documentElement]
    # xml <? dbconnect setzten ?>
    keylset attrlist interface $sqlconnect::interface
    foreach par [sqlconnect getconnectargs] {
	set attr [lindex $par 0]
	if {$attr=="password"} continue
	if {[info exist sqlconnect::$attr]} {
	    keylset attrlist $attr [set sqlconnect::$attr]
	}
    }
    $data_node appendChild [$dom_doc createProcessingInstruction \
			    dbconnect $attrlist]
    #Schema aus DB DataDictionary auslesen und zu XML umwandeln
    DomSchemaVisitor myDSVisitor -guiobject [self] -rdom_doc $dom_doc \
	-dbname [sqlconnect set dbank]
    sqlconnect extract_schema myDSVisitor 
    # Puszeichen bei Tree setzten
    $win.panedwin.tree.tree autosetmode 
    myDSVisitor destroy
    set file_name {}
}
ProgGui proc readxmlschema {{file {}}} {
    [self] instvar win data_node dom_doc file_name
    set types {
        {"XML DB Schema"            {.xmldbschema}     }
        {"All files"            *}
    }
    if {$file==""} {
	set file [tk_getOpenFile -filetypes $types -parent .]
    }
    if {$file == ""} { return }
    set fileh [open $file r]
    [self] clearSchema
    set dom_doc [dom parse [read $fileh]]
    close $fileh
    set data_node [$dom_doc documentElement]
    if {[$data_node nodeName]!="database"} {
        global lan
        $dom_doc delete
	set dom_doc ""
        tk_messageBox -message $lan(message.wrongxml) -type ok -icon error
	return
    }
    set file_name $file
    xmlSchemaExtractor extract_schema [self] $data_node
    $win.panedwin.tree.tree autosetmode 
}
ProgGui proc clearSchema {} {
    [self] instvar dom_doc hlist pathnode
    catch {[self] editSchemaUpdate}
    if {[info exist dom_doc] && $dom_doc!=""} {
	$dom_doc delete
    }
    $hlist delete all
}
#
# Die zwei Prozeduren addElem und deleteElem
# bewltigen das Anzeigen von DB Struktur (XML Schema) als Tix TreeWidget
#
# node = tDom node
# pos  = tDom node
# child (bool) wenn true dann wird pos als Elternteil implementiert (parent)
#                        sonst als Nachfolger
# Ausnahme wenn wurzel Node dann pos="root"
#
#  newName ndert das einzige Sichtbare Eigenschaft Name
#
ProgGui proc addElem {node pos child} {
    [self] instvar pathnode hlist
    set nodedisplay {
	{database database} {table table} 
	{attr attribut} {attrgroup attr_group}
	{assoziationcollection assoziationcollection}
	{assoziationtarget assoziationtarget}
	{label label}
    }
    if {[$node nodeName]=="attr"} {
	if {[$node hasAttribute primary_key] && 
	    [$node getAttribute primary_key]} {
	    set imagetyp [tix getimage primary_key]
	} else {
	    set imagetyp [tix getimage attribut]
	}
    } else {
	set imagetyp [tix getimage [keylget nodedisplay [$node nodeName]]]
    }
    if {[$node nodeName]=="label"} {
	set ntext label
    } else {
	set ntext [$node getAttribute name] 
    }
    if {$child} {
	if {$pos=="root"} {
	    set newpath $node
	} else {
	    set newpath $pathnode($pos).$node
	}
	$hlist add $newpath -itemtype imagetext \
	    -text $ntext \
	    -image $imagetyp \
	    -data $node
    } else {
	set parent [$hlist info parent $pathnode($pos)]
	set newpath $parent.$node
	$hlist add $newpath -itemtype imagetext \
	    -text $ntext \
	    -image $imagetyp \
	    -data $node -before $pathnode($pos)
    }
    set pathnode($node) $newpath
    # Tabellen Icon Anpassen !!! hack
    if  {[$node nodeName]=="table"} {
	[self] applyChanges $node
    }
}
ProgGui proc deleteElem {node} {
    [self] instvar pathnode hlist edit_node
    set path $pathnode($node)
    #puts "delete $node $path"
    $hlist delete entry $path
    unset pathnode($node)
    if {[info exist edit_node] && $edit_node==$node} {
	[self] editForget
    }
}
# Diese Prozedur verschiebt ganze HList unterstrukturen
ProgGui proc moveElem {node pos child} {
    [self] instvar pathnode hlist
    set path $pathnode($node)
    set pathlen [expr [string length $path]-1]
    # Hier werden alle nachkommen (auch Kinder der Kinder u.s.w) der Node
    # Ermittelt
    for {set moveitem $path} {[string range $moveitem 0 $pathlen]==$path} {set moveitem [$hlist info next $moveitem]} {
	lappend movelist [list \
			      $moveitem \
			      [$hlist entrycget $moveitem -itemtype] \
			      [$hlist entrycget $moveitem -text] \
			      [$hlist entrycget $moveitem -image] \
			      [$hlist entrycget $moveitem -data]]
    }
    $hlist delete entry $path
    set pathlen [string length $path]
    if {$child} {
	if {$pos=="root"} {
	    set newpath $node
	} else {
	    set newpath $pathnode($pos).$node
	}
    } else {
	set parent [$hlist info parent $pathnode($pos)]
	set newpath $parent.$node
    }
    #puts "MV $movelist"
    foreach item $movelist {
	set mpath [string range [lindex $item 0] $pathlen end]
	set itemtype [lindex $item 1]
	set text [lindex $item 2]
	set image [lindex $item 3]
	set data [lindex $item 4]
	set pathnode($data) ${newpath}${mpath}
	#puts "mp $mpath it $itemtype text $text image $image $data"
	if {$child || $mpath!=""} {
	    $hlist add ${newpath}${mpath} -itemtype $itemtype \
		-text $text -image $image -data $data
	} else {
	    $hlist add ${newpath}${mpath} -itemtype $itemtype \
		-text $text -image $image -data $data -before $pathnode($pos)
	}
    }
}
ProgGui proc newName {node name} {
    [self] instvar pathnode hlist
    set path $pathnode($node)
    #puts "configure name $node $path"
    $hlist entryconfigure $path -text $name
}
# Vernderd das Ikon zu neuen Anfordernissen
ProgGui proc applyChanges node {
    [self] instvar pathnode hlist
    set path $pathnode($node)
    if {[$node nodeName]=="table"} {
	set image_now [$hlist entryconfigure $path -image] 
	if {[$node hasAttribute type]} {
	    set image_new "table[$node getAttribute type]"
	    
	} else {
	    set image_new table
	}
	if {[tix getimage $image_new]!=$image_now} {
	   $hlist entryconfigure $path -image [tix getimage $image_new] 
	}
    } elseif {[$node nodeName]=="attr"} {
	set image_now [$hlist entryconfigure $path -image] 
	if {[$node hasAttribute primary_key] && 
	    [$node getAttribute primary_key]} {
	    set image_new primary_key
	} else {
	    set image_new attribut
	}
	if {[tix getimage $image_new]!=$image_now} {
	   $hlist entryconfigure $path -image [tix getimage $image_new] 
	}	
    }
}
ProgGui proc handle_exit {} {
    global lan
    catch {[self] editSchemaUpdate}
    if {[tk_messageBox -message $lan(dialog.endmsg) -icon question -type okcancel]=="ok"} { exit }
}
#
# Ein Visitor fr extrahieren des Schema von DB Struktur 
# (mit HIlfe des MySqlSchemaExtractor Objects)
#
Class DomSchemaVisitor -parameter {
    guiobject
    rdom_doc
    dbname
}
DomSchemaVisitor instproc init args {
    [self] instvar guiobject dbname rdom_doc
    set node [$rdom_doc documentElement]
    $node setAttribute name $dbname
    $guiobject addElem $node root 1
}
DomSchemaVisitor instproc newtable newtable {
    [self] instvar hlist table_node rdom_doc guiobject
    set table_node [$rdom_doc createElement table]
    $table_node setAttribute name $newtable
    set db_node [$rdom_doc documentElement]
    $db_node appendChild $table_node
    $guiobject addElem $table_node $db_node 1
}
DomSchemaVisitor instproc newattribute attr {
    [self] instvar hlist table_node rdom_doc guiobject
    set node [$rdom_doc createElement attr]
    foreach key [keylkeys attr] {
	set value [keylget attr $key]
	if {$key=="valuelist"} {
	    tdom_setvaluelist $node $value
	} else {
	    $node setAttribute $key $value
	}
	if {$key=="primary_key" && $value=="1"} {
	    $node setAttribute $key $value
	}
    }
    $table_node appendChild $node
    $guiobject addElem $node $table_node 1
}
ProgGui setwin {}
# Ein Service-Objekt fr Manipulationen auf XML-DBSchema
# es bertregt die Vernderungen direkt zu ProgGui (View des Schemas)
SchemaEdit serviceSEdit
#ProgGui readxmlschema uni2.xmldbschema
if {!$tcl_interactive && [llength $argv]==1} {
    ProgGui readxmlschema $argv
}
wm deiconify .

