#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: prog_func.tcl,v 1.12 2000/10/15 17:19:20 artur Exp $
#
# Information:
# Modul (benutzt von Schema Editor)
# Callback Prozeduren des SchemaEditor (Aufgerufen durch Benutzer Interaktion)
ProgGui proc saveasxml {} {
   [self] instvar data_node file_name window
    set types {
        {"XML files"         {.xmldbschema}  }
        {"All files"            *}
    }
    if {![info exists file_name] && $file_name!=""} {
	set file_name [sqlconnect set dbank].xmldbschema
    }
    set f_name [tk_getSaveFile -filetypes $types -parent . \
            -initialfile $file_name -defaultextension .xmldbschema]
    if {$f_name != ""} {
	set file_name $f_name
        set fh [open $file_name w]
	puts $fh "<?xml version='1.0' encoding='iso-8859-1'?>\n<!DOCTYPE database SYSTEM \"dbschema.dtd\">\n[$data_node asXML]"
	close $fh
    }
}

ProgGui proc extend_view {} {
    [self] instvar win
    set tree $win.panedwin.tree.tree
    $tree open 
    
}
ProgGui proc restrict_view {} {
    [self] instvar win
    set tree $win.panedwin.tree.tree
    $tree open 
}
ProgGui proc changeView {} {
    [self] instvar v_attr v_attr_group v_ass_target \
	v_ass_collection v_aggr_table v_child_table \
	v_ass_table v_table_label hlist data_node
    set top [$hlist info children]
    for {set path [$hlist info next $top]} {$path!=""} {set path [$hlist info next $path]} {
	set hidden [$hlist info hidden $path]
	set node [$hlist entrycget $path -data]
	set nodename [$node nodeName]
	# berprfe wenn direkte entsprechung
	array set namehash {attr v_attr attrgroup v_attr_group 
	    assoziationcollection v_ass_collection 
	    assoziationtarget v_ass_target
	    label v_table_label} 
	if {[info exist namehash($nodename)]} {
	    set var $namehash($nodename)
	    if {$hidden==[set $var]} {
		if {[set $var]} {
		    $hlist show entry $path
		} else {
		    $hlist hide entry $path
		}
	    }
	    continue
	}
	switch $nodename {
	    table {
		if {[$node hasAttribute type]} {
		    set type [$node getAttribute type]
		    switch $type {
			child {
			    if {$hidden==$v_child_table} {
				if {$v_child_table} {
				    $hlist show entry $path
				} else {
				    $hlist hide entry $path
				}
			    }
			}
			relationship {
			    if {$hidden==$v_ass_table} {
				if {$v_ass_table} {
				    $hlist show entry $path
				} else {
				    $hlist hide entry $path
				}
			    }
			}
		    }
		} else {
		    # Aggregierte Tabelle
		    if {[[$node parentNode] nodeName]=="table"} {
			if {$hidden==$v_aggr_table} {
			    if {$v_aggr_table} {
				$hlist show entry $path
			    } else {
				$hlist hide entry $path
			    }
			}
		    }
		}
	    }
	}
    }
}
ProgGui proc mlist_sel {list} {
    [self] instvar hlist
    if {$list!=""} {
	[self] editSchemaNode [$hlist info data $list]
    }
}
# Benuzt um Eigenschaftenfenster auszublenden
# es wird nacher auch nicht ausgewertet
# z.B wenn das Node gelt wurde
ProgGui proc editForget {} {
    [self] instvar actuel_edit
    if {$actuel_edit!=""} {
        pack forget [$actuel_edit set win]
	set actuel_edit {}
    }    
}
# Die Vernderungen quitieren
ProgGui proc editSchemaUpdate {} {
    [self] instvar actuel_edit
    if {$actuel_edit!=""} {
        $actuel_edit applyChanges
    }    
}
# Diese Prozedur ist aus effizienzgrnden ein bischen tricky
# Es existieren viele Objekte fr das Editieren von einzelnen Schema Typen
# Pro Typ wird immer wieder das gleiche Fenster benutzt und wenn
# nicht bentigt ausgeblendet
ProgGui proc editSchemaNode {node} {
    [self] instvar win editframe actuel_edit edit_node
    [self] editSchemaUpdate
    # Typ der Node ermitteln
    set nodeType [$node nodeName]
    set objname {
        {attr SchemaEditAttribute}
        {database SchemaEditDatabase}
        {table SchemaEditTable}
        {attrgroup SchemaEditGroup}
	{label SchemaEditLabel}
	{assoziationcollection SchemaEditCollection}
	{assoziationtarget SchemaEditTarget}
    }
    set objtyp [keylget objname $nodeType]
    # Wenn ein Objekt dieses Types nicht Existiert dann init und map
    if {[[self] info children my$objtyp]==""} {
        $objtyp [self]::my${objtyp} 
        [self]::my${objtyp} map $editframe.edit_$nodeType
    }
    # Wenn neues Objekt ungleich altes von Typ dann forget (aus der Sicht)
    if {$actuel_edit!="" && $objtyp!=[$actuel_edit info class]} {
        pack forget [$actuel_edit set win]
        set actuel_edit {}
    }
    if {$actuel_edit==""} {
        set actuel_edit my${objtyp}
        #puts "WIN [$actuel_edit set win]"
        pack [$actuel_edit set win] -side left -anchor nw
    }
    # Aktualisiere die Anzeige auf Node
    $actuel_edit handleNewNode $node
    set edit_node $node
    # Die vernderungen mssen auch auf die GUI abgebildet werden
    # z.B. Name
}
ProgGui proc elementUp {} {
    [self] instvar hlist
    set entry [$hlist info selection]
    if {$entry==""} return
    set node [$hlist info data $entry]
    if {$node==""} return
    if {![[self] elemMoveable $node]} return
    if {[set prev_node [$node previousSibling]]==""} return
    if {![[self] elemMoveable $prev_node]} return
    serviceSEdit moveElem $node $prev_node 0
    selectPerNode $node
}
ProgGui proc elementDown {} {
    [self] instvar hlist
    set entry [$hlist info selection]
    if {$entry==""} return
    set node [$hlist info data $entry]
    if {$node==""} return
    if {![[self] elemMoveable $node]} return
    if {[set next_node [$node nextSibling]]==""} return
    if {![[self] elemMoveable $next_node]} return
    if {[set nn_node [$next_node nextSibling]]!=""} {
	serviceSEdit moveElem $node $nn_node 0
    } else {
	serviceSEdit moveElem $node [$node parentNode] 1
    }
    selectPerNode $node
}
# Finde heraus ob ein Node Bewglich ist
ProgGui proc elemMoveable {node} {
    set type [$node nodeName]
    switch $type {
	attr {
	    if {[$node hasAttribute primary_key] && 
		[$node getAttribute primary_key]} {
		return 0
	    } else {
		return 1
	    }
	}
	table {
	    return 1
	}
	attrgroup {
	    return 1
	}
    }
    return 0
}
ProgGui proc selectPerNode {node} {
    [self] instvar hlist pathnode
    set path $pathnode($node)
    $hlist selection clear
    $hlist selection set $path
}
# Prozeduren fr die Kontextbezogene erzeugung von popupmenus
ProgGui proc popmenuTree {x y} {
    [self] instvar win hlist
    global lan
    set entry [$hlist info selection]
    if {$entry==""} { return }
    set node [$hlist info data $entry]
    if {$node==""} { return }
    set type [$node nodeName]

    set m $win.popmenu
    destroy $m
    menu $m -tearoff 0
    if {[lcontain {table attr} $type] && 
	[[$node parentNode] nodeName]!="attrgroup"} {
        $m add command -label $lan(popup.newgroup) \
            -command "[self] newAttrGroup $node"
    }
    if {$type=="attrgroup"} {
	$m add command -label $lan(popup.delgroup) \
	    -command "[self] deleteGroup $node"
    }
    if {$type=="assoziationtarget" || $type=="assoziationcollection"} {
	$m add command -label $lan(popup.delassoziation) \
	    -command "[self] deleteAssoziation $node"
	$m add command -label $lan(popup.editassoziation) \
	    -command "AssAssistent execute $ProgGui::data_node $node"
    }
    if {$type=="assoziationcollection"} {
	if {[$node getAttribute type]=="reference" && [$node selectNodes child::assoziationcollection/child::paticipant/attribute::table]!=[$node getAttribute name]} {
	    $m add command -label $lan(popup.ass2aggr) \
		-command "[self] ass2aggr $node "
	    
	}
    }
    if {$type=="table" && [[$node parentNode] nodeName]=="table"} {
	$m add command -label $lan(popup.delnestedTable) \
	    -command "[self] deleteNestedTable $node"
	# Aggregation zu Assoziation umwandeln
	if {[$node hasAttribute reference]} {
	    $m add command -label $lan(popup.aggr2ass) \
		-command "[self] aggr2ass $node"
	}
    }
    if {$type=="table"} {
	if {[$node selectNodes child::label]==""} {
	    $m add command -label $lan(popup.definelab) \
		-command "[self] defineLabel $node"
	}
	$m add command -label $lan(popup.delete) \
	    -command "serviceSEdit deleteElem $node"
    }
    $m add command -label $lan(popup.edit) \
        -command "[self] editSchemaNode $node"
    tk_popup $m $x $y
}
# Prozedure Callbacks fr Pop-Up Mens
ProgGui proc newAttrGroup {node} {
    [self] instvar win hlist
    global lan  
    set doc [$node ownerDocument]
    set gnode [$doc createElement attrgroup]
    set name [Object autoname group]
    $gnode setAttribute name $name
    if {[$node nodeName]=="table"} {
        set node [$node firstChild]
    }
    [$node parentNode] insertBefore $gnode $node
    [self] addElem $gnode $node 0
    [self] editSchemaNode $gnode
}
# Definieren von der Tabellen-Etikette
# Benutzerfreundliches Schlssel Kandidat 
# (Attribute fr Anzeige der Fremdschlssel)
ProgGui proc defineLabel {node} {
    set node [$node firstChild]
    # Setzt Label als erstes Child in der Tabelle node
    set doc [$node ownerDocument]
    set lnode [$doc createElement label]
    serviceSEdit addElem $lnode $node 0
    [self] editSchemaNode $lnode
}
# Auflsen der Gurppe die Einzelnen Elemente gehen jedoch nicht verloren
ProgGui proc deleteGroup {node} {
    set posnode [$node nextSibling]
    foreach ch_node [$node childNodes] {
	serviceSEdit moveElem $ch_node $posnode 0
    }
    serviceSEdit deleteElem $node
}
# Delete Assoziation
ProgGui proc deleteAssoziation {node} {
    set assname [$node getAttribute name]
    set anodes [$node selectNodes /descendant::assoziationtarget\[@name=\"$assname\"\]]
    # Suche assoztioncontainer
    set cnodes [$node selectNodes /descendant::assoziationcollection\[@name=\"$assname\"\]]
    set anodes [concat $anodes $cnodes]
    set rltable [[lindex $cnodes 0] parentNode]
     if {[$rltable hasAttribute type] && [$rltable getAttribute type]=="relationship"} {
	$rltable removeAttribute type
	ProgGui applyChanges $rltable
	#puts HIER
    }
    foreach dnode $anodes {
	serviceSEdit deleteElem $dnode
    }
}
# Kind Tabelle oder Aggregierte Tablele wieder Freigeben
ProgGui proc deleteNestedTable {node} {
    [self] instvar data_node
    foreach delattr {type reference inherittype inheritkey} {
	if {[$node hasAttribute $delattr]} {
	    $node removeAttribute $delattr
	}
    }
    serviceSEdit moveElem $node $data_node 1
    [self] applyChanges $node
}
ProgGui proc aggr2ass {table} {
    [self] instvar data_node dom_doc
    set col_table [lindex [$table selectNode ancestor::table] 0]
    set collectionname "[$col_table getAttribute name][$table getAttribute name]"
    # Was wenn gleichnammige collection bereits existiert (to chuj)
    set ac_node [$dom_doc createElement assoziationcollection]
    $ac_node setAttribute name $collectionname
    $ac_node setAttribute type reference
    set p_node [$dom_doc createElement participant]
    $p_node setAttribute reference [$table getAttribute reference]
    $p_node setAttribute table [$col_table getAttribute name]
    $ac_node appendChild $p_node
    serviceSEdit addElem $ac_node $table 

    set at_node [$dom_doc createElement assoziationtarget]
    $at_node setAttribute table [$table getAttribute name]
    $at_node setAttribute name $collectionname

    serviceSEdit addElem $at_node $col_table 

    $table removeAttribute reference
    serviceSEdit moveElem $table $data_node
}
ProgGui proc ass2aggr {node} {
    [self] instvar data_node
    set table [lindex [$node selectNode ancestor::table] 0]
    set reference [$node selectNodes child::participant/attribute::reference]
    set container [$node selectNodes child::participant/attribute::table]
    set col_table [$data_node selectNodes descendant::table\[@name=\"$container\"\]]
    # Entferne die Assoziatione Collection und Target
    serviceSEdit deleteElem $node
    serviceSEdit deleteElem [$col_table selectNodes \
				 child::assoziationtarget\[@table=\"[$table getAttribute name]\"\]]
    # Neue Attributte bei Element-Tabelle setzten und einbetten
    $table setAttribute reference $reference
    serviceSEdit moveElem $table $col_table
}
ProgGui proc reverseEngeneering {type} {
    [self] instvar data_node
    if {[[self] info children reverse]!=""} {
	return
	[self]::reverse destroy
    }
    RE_$type [self]::reverse -schema_node $data_node
    [self]::reverse execute
}
# xmlSchemaExtraktor tranversiert das tDom Struktur
# der DB Schema un setzt es auf die anrufe (callback)
# des Visitors Object
# alle Attribute werden unverndert als keyedlist zurckgegeben
Object xmlSchemaExtractor
xmlSchemaExtractor proc extract_schema {guiobject schema_node} {
    # tDom
    $guiobject addElem $schema_node root 1
    foreach table_node [$schema_node childNodes] {
        if {[$table_node nodeType]=="ELEMENT_NODE"
            && [$table_node nodeName]=="table"} {
            $guiobject addElem $table_node $schema_node 1
            [self] extract_table $guiobject $table_node
        }
    }

}
xmlSchemaExtractor proc extract_table {guiobject table_node} {
    # tDom
    foreach attr_node [$table_node childNodes] {
        if {[$attr_node nodeType]=="ELEMENT_NODE"
            && [$attr_node nodeName]=="attr"} {
            $guiobject addElem $attr_node $table_node 1
        } elseif {[$attr_node nodeType]=="ELEMENT_NODE"
		  && [$attr_node nodeName]=="attrgroup"} {
	    # Attribut Gruppe; kann hier als Tabelle behandelt werden
	    $guiobject addElem $attr_node $table_node 1
	    [self] extract_table $guiobject $attr_node
	} elseif {[$attr_node nodeType]=="ELEMENT_NODE"
		  && [$attr_node nodeName]=="table"} {
	    # Aggregation oder Vererbung geschaftelete Tablellen
	    $guiobject addElem $attr_node $table_node 1
	    [self] extract_table $guiobject $attr_node
	} elseif {[$attr_node nodeType]=="ELEMENT_NODE"
		  && ([$attr_node nodeName]=="assoziationtarget" || 
		      [$attr_node nodeName]=="assoziationcollection")} {
	    $guiobject addElem $attr_node $table_node 1
	} elseif {[$attr_node nodeType]=="ELEMENT_NODE"
		  && ([$attr_node nodeName]=="label")} {
	    $guiobject addElem $attr_node $table_node 1
	}
    }
} 

